## metview 4.5.6

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
#
#  Metview-specific:
#  -DMETVIEW_SITE=ecmwf | other
#  -DMETVIEW_SCRIPT=name-of-generated-startup-script
#  -DMARS_HOME=/path/to/MARS/home  (requires WITH_MARS=ON)
#  -DMAGICS_PATH=/path/to/magics   (requires WITH_PLOTTING=ON)
#  -DEXTRA_TITLE=extra-title-string
#  -DLOG_DIR=/path/to/dir/for/module/log/files
#  -DODB1_USE_SCRIPT_PATH=/path/to/odb1/use/script

cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

project( metview C CXX Fortran)


set(MV_BIN_DIR bin/metview_bin) # all executables and scripts apart from the startup script should go here


set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE OFF)

set(METVIEW_INSTALL_BIN_DIR "${MV_BIN_DIR}" CACHE PATH "Metview installation directory for executable files")

include( ecbuild_system )


ecbuild_requires_macro_version( 1.2 )

ecbuild_enable_fortran( REQUIRED )


###############################################################################
# some options of this project

option( ENABLE_UI            "enable the user interface"                          ON )
option( ENABLE_MOTIF         "enable the classic Motif-based user interface"      OFF )
option( ENABLE_PLOTTING      "enable the plotting module"                         ON )
option( ENABLE_OPERA_RADAR   "enable OPERA radar filter module (requires proj4)"  AUTO )
option( ENABLE_MARS          "enable MARS access"                                 OFF )
option( ENABLE_ODB           "enable ODB"                                         OFF )
option( ENABLE_MARS_ODB      "enable ODB in MARS"                                 OFF )
option( ENABLE_USAGE_LOG     "enable usage logging (only at ECMWF)"               OFF )
option( ENABLE_QT_DEBUG      "enable Qt debugging messages"                       OFF )
option( ENABLE_INPE          "enable INPE modules"                                ON )
option( ENABLE_WEATHER_ROOM  "enable Weather Room plot export (only at ECMWF)"    OFF )
option( ENABLE_NETWORK_PROXY "enable network proxy settings for WMS"              OFF )
option( ENABLE_EXPERIMENTAL  "enable experimental modules"                        OFF )
option( ENABLE_CONTRIB       "enable externally contributed modules"              OFF )
 
###############################################################################


# ensure we can add non-existent dependencies - required for generating icon files
if( ${CMAKE_VERSION} VERSION_GREATER "2.9.9" )
    cmake_policy(SET CMP0046 OLD)
endif()



# if we don't explicitly state that we're at ECMWF, then assume we're not, and use the generic config
if(NOT METVIEW_SITE STREQUAL ecmwf)
    set( SITE_WMO_CODE "255")    # DO WE NEED AN OPTION TO ALLOW INSTALLERS TO SPECIFY THIS?
    set( MV_ENVIRON    "common")
    set( AT_ECMWF "FALSE" )
    message("Building outside ECMWF")
else()
    set( SITE_WMO_CODE "098")
    set( MV_ENVIRON    "ecm_lnx64")
    set( AT_ECMWF "TRUE" )
    add_definitions( -DECMWF )
    message("Building inside ECMWF")
endif()


if(DEFINED EXTRA_CONFIG_PATH)
    message(STATUS "Will search ${EXTRA_CONFIG_PATH} for additional config files")
endif()



# default startup script name
if(NOT DEFINED METVIEW_SCRIPT )
    set( METVIEW_SCRIPT "metview" )
endif()

set(FULL_STARTUP_SCRIPT_PATH ${CMAKE_BINARY_DIR}/bin/${METVIEW_SCRIPT})

# ensure we don't build shared libraries
set(BUILD_SHARED_LIBS OFF)


# Weather Room plot export (ECMWF only)
if(ENABLE_WEATHER_ROOM)
    if(AT_ECMWF)
        ecbuild_add_extra_search_paths( boost ) # Weather Room export needs Boost
        find_package( Boost 1.49.0 )            # Weather Room export needs Boost
        set(MV_WEATHER_ROOM_BUILT true)
    else()
        message(WARNING "ENABLE_WEATHER_ROOM only available when building at ECMWF")
    endif()
else()
    set(MV_WEATHER_ROOM_BUILT false)
endif()


if(ENABLE_INPE)
    set(METVIEW_INPE true)
endif()


# --------------------------------
# look for MARS client source code
# --------------------------------

if(MARS_SOURCE_PATH)
    # if the user specified a path, then only look there
    set(MARS_SOURCE_PATHS ${MARS_SOURCE_PATH}/src)
else()
    # otherwise look in some default locations
    set(MARS_SOURCE_PATHS ${CMAKE_SOURCE_DIR}/src/libMars         # embedded in source
                          ${CMAKE_SOURCE_DIR}/src/libMarsClient   # embedded in source
                          ${CMAKE_SOURCE_DIR}/../client/src       # in external dir
                          ${CMAKE_SOURCE_DIR}/../mars-client/src) # in external dir
endif()


# search each MARS path for a given source file
set(FOUND_MARS_SOURCE false)
foreach( mars_path ${MARS_SOURCE_PATHS} )
    if (NOT FOUND_MARS_SOURCE)
        message(STATUS "Looking for MARS source in ${mars_path}")
        if (EXISTS ${mars_path}/request.c)
            set(MARS_SOURCE_PATH ${mars_path})
            set(FOUND_MARS_SOURCE true)
            message(STATUS "Found MARS source in ${mars_path}")
        else()
        endif()
    endif()
endforeach()

if (NOT FOUND_MARS_SOURCE)
    message(FATAL_ERROR "MARS source is required, but was not found in " ${MARS_SOURCE_PATHS})
endif()


# ensure the MARS client source is included in the tarball (if necessary)
if(NOT ${MARS_SOURCE_PATH} STREQUAL ${CMAKE_SOURCE_DIR}/src/libMars)
    list( APPEND CPACK_SOURCE_INSTALLED_DIRECTORIES
            "${MARS_SOURCE_PATH}" "src/libMarsClient")
endif()



# look for curl because it is needed for the Mars Web API client
find_package(CURL)

# local MARS access
if(ENABLE_MARS)
    set( MARS_ACCESS MARS_local )
    set( METVIEW_MARS 1 )
    if(DEFINED MARS_LOCAL_HOME)
        message(STATUS "MARS_LOCAL_HOME=${MARS_LOCAL_HOME}")
        if(NOT EXISTS ${MARS_LOCAL_HOME})
            message(FATAL_ERROR "MARS_LOCAL_HOME (${MARS_LOCAL_HOME}) does not exist")
        else()
            set(MARS_HOME ${MARS_LOCAL_HOME})
        endif()
    else()
        message(FATAL_ERROR "If setting local MARS access, -DMARS_LOCAL_HOME=/path/to/mars/home must be provided.")
    endif()

    if(ENABLE_MARS_ODB)
        set(ENABLE_ODB 1)
        set(METVIEW_MARS_ODB 1)
    endif()

    #find_library( FDB  REQUIRED )
    #message(STATUS "FDB: ${FDB_LIBRARIES}" )

else()
    if(${CURL_FOUND})
        set( MARS_ACCESS MARS_webapi )
    else()
        set( MARS_ACCESS MARS_none )
        add_definitions(-DNOCURL)
        message(STATUS "Could not find the Curl library - disabling Web API Mars")
    endif()
endif()


if(AT_ECMWF)
    find_package(FDB REQUIRED)
else()
    find_package(FDB)
endif()

message(STATUS "FDB: ${FDB_LIBRARIES}" )

if( NOT FDB_FOUND )
    message(STATUS "NO FDB" )
endif()



###############################################################################
# local project requirements

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )

ecbuild_use_package( PROJECT grib_api VERSION 1.13.0 REQUIRED )
list( APPEND METVIEW_TPLS grib_api )


if(ENABLE_ODB)
    ecbuild_use_package( PROJECT odb_api  VERSION 0.10.1 ) # requires at least this version
    if( ODB_API_FOUND )

        # does this version use eckit?
        list(FIND ODB_API_LIBRARIES eckit ODB_ECKIT_INDEX)
   

        if (NOT ODB_ECKIT_INDEX EQUAL -1)  # is an eckit version
            add_definitions(-DODB_ECKIT)
        endif()

        set(METVIEW_ODB 1)

        if(ODB_API_PATH)
            set(ODB_API_LIB_DIR ${ODB_API_PATH}/lib)
            set(ODB_API_BIN_DIR ${ODB_API_PATH}/bin)
        endif()

        add_definitions(-DMETVIEW_ODB_NEW -DMETVIEW_ODB)
        set(METVIEW_ODB_API_INCLUDE_DIRS ${ODB_API_INCLUDE_DIRS}
                                         ${ODB_API_INCLUDE_DIRS}/..
                                         ${ODB_API_INCLUDE_DIRS}/../eclib
                                         ${ODB_API_INCLUDE_DIRS}/../eclib/eclib
                                         ${ODB_API_INCLUDE_DIRS}/odblib) 
    else()
        if(ENABLE_MARS_ODB)
            message(FATAL_ERROR "ENABLE_ODB was set, but ODB not found")
#            message(FATAL_ERROR "ENABLE_MARS_ODB was set, but ODB not found")
            set(ENABLE_MARS_ODB 0)
            set(METVIEW_MARS_ODB 0)
        endif()
    endif()
    ###list( APPEND METVIEW_TPLS odb_api )


    # ODB-1

    ecbuild_use_package( PROJECT ODB )
    
    if(ODB_FOUND)
        if(EXISTS ${ODB_PATH}/bin)
            if(EXISTS ${ODB_PATH}/bin/odbsql)
                add_definitions(-DMETVIEW_ODB_OLD)
                set(ENABLE_ODB1 "ON")

                if(ODB1_USE_SCRIPT) # was an ODB-1 use script name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_USE_SCRIPT=${ODB1_USE_SCRIPT}")
                endif()

                if(ODB1_MODULE) # was an ODB-1 module name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_MODULE=${ODB1_MODULE}")
                endif()

                if(ODB1_VERSION) # was an ODB-1 module name passed?
                    set(MV_ODB1_VERSION ${ODB1_VERSION})
                else()
                    set(MV_ODB1_VERSION "ANY")
                endif()

            else()
                message(WARNING "ODB-1 support is DISABLED - No odbsql script found in ${ODB_PATH}/bin")
            endif()
        else()
            message(WARNING "ODB-1 found, but no bin directory in ${ODB_PATH}")
        endif()
    else()
        message(WARNING "ODB-1 not found!")
    endif()
endif()



# ------------------------------------------------------------------------
# MACRO metview_get_magics_config
# Calls the magics-config script to query a particular piece of info
# (MAGICS_INFO) from Magics. Output is in MAGICS_OUT
# ------------------------------------------------------------------------

macro(metview_get_magics_config MAGICS_INFO MAGICS_OUT)

    set(command ${MAGICS_BIN_PATH}magics-config --${MAGICS_INFO})

    execute_process(COMMAND ${command}
                    RESULT_VARIABLE cmdres
                    OUTPUT_VARIABLE ${MAGICS_OUT}
                    RESULT_VARIABLE resultvar
                    ERROR_VARIABLE  cmderr
                    OUTPUT_STRIP_TRAILING_WHITESPACE)

    if(NOT "${resultvar}" STREQUAL "0")
        message(STATUS "Error running command: ${command}")
        message(STATUS "${resultvar}")
        message(STATUS "Consider supplying -DMAGICS_PATH if Magics is installed in a non-standard location")
        message(FATAL_ERROR "Aborting.")
    endif()

endmacro()



if(ENABLE_PLOTTING)
    ecbuild_use_package( PROJECT magics VERSION 2.24.3)
    if( MAGICS_FOUND )

        if(DEFINED MAGICS_PATH) # user supplied MAGICS_PATH
            message (STATUS "MAGICS_PATH supplied: ${MAGICS_PATH}")
            set(MAGICS_BIN_PATH "${MAGICS_PATH}/bin/") # note the trailing slash
        else()
            # if MAGICS_PATH was not defined, then we probably picked up Magics from
            # a system directory. We use MAGICS_CMAKE_DIR and work backwards from there
            # to find the bin directory . This assumes a standard Magics installation
            # where we have: <prefix>/bin  and  <prefix>/share/magics/cmake
            # so the bin directory is ${MAGICS_CMAKE_DIR}/../../../bin

            set(MAGICS_BIN_PATH "${MAGICS_CMAKE_DIR}/../../../bin/")
            message (STATUS "MAGICS_PATH not supplied: bin dir should be at ${MAGICS_BIN_PATH}")
        endif()

        metview_get_magics_config("libdir" magout)
        list(APPEND MAGICS_LIBRARIES "-L${magout}")
        set(MAGICS_LIB_DIR ${magout})

        list(APPEND MAGICS_LIBRARIES "-lMagWrapper")
        set(MAGICS_METEOGRAM_SCRIPT "${MAGICS_BIN_PATH}metgram")

=== scripts/CMakeLists.txt ===

set(scripts
    dump metview-mail mvrun mvrun_c mvrun_lnx
    logrun metview_stat metview_create_user_dir
    metview_patches
    mvusage metview_help set_mars_env
    document_macros.pl mv_grib_dump
    metview_local.${MV_ENVIRON} metview_local2.${MV_ENVIRON}
    MarsTiggeWrapper
    MarsOdbWrapper
    generate_video
    mv_compress mv_mail mv_uniquename
    mv_odbsql mv_obstat
    mv_mars_catalog.py
    mv_flextra_prep.mv mv_flextra_prep mv_flextra_run
    mv_flexpart_run
    mv_rttov_run
    mv_scm_run mv_scm_vis.mv
    mv_vapor_prep.mv mv_vapor_gui
    select_mars_config
)

if(AT_ECMWF)
    list(APPEND scripts mv_debug_env.sh)
endif()



# handle these script files
metview_script_files(SCRIPT_FILES ${scripts})




##############################################################
#
# generate the 'compile' script for inline C/Fortran in Macro

# only use the first library returned in EMOS_LIBRARIES
# - this is because it can also return a list of shared libraries used by
# the PGI compiler which can then not be found at run-time.
list(GET EMOS_LIBRARIES 0 EMOS_FIRST_LIB)


# for GRIB_API, we *might* get something like
# grib_api;grib_api_f77;grib_api_f90;/usr/lib64/libjasper.so;/usr/lib64/libjpeg.so;/usr/lib64/libm.so
# which is not all that we need to link. So we convert 'grib_api' into '-lgrib_api'
# and for the Fortran libraries.

set(GRIB_API_LIBRARIES_STR " ${GRIB_API_LIBRARIES}") # add a space to the beginning

string (REPLACE ";"         " "           GRIB_API_LIBRARIES_STR    "${GRIB_API_LIBRARIES_STR}")
string (REPLACE " grib_api" " -lgrib_api" GRIB_API_LIBRARIES_STR    "${GRIB_API_LIBRARIES_STR}")
string (REPLACE ";"         " "           EMOS_LIBRARIES_STR        "${EMOS_FIRST_LIB}")


set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${PTHREAD_LIB}") # add pthread in case needed

# if we are linking with shared GRIB_API libraries, then in order to be able
# to run compiled inline Fortran/C/Macro programs, we will need to set
# LD_LIBRARY_PATH to where GRIB_API was installed (this should only be
# needed if GRIB_API was installed in a non-default location).
# GRIB_API_LIB_DIR will be added to METVIEW_LD_PATHS and used in compile.in.

# first, if CMAKE_PREFIX_PATH is defined and GRIB_API_PATH is not, then
# GRIB_API might be installed in CMAKE_PREFIX_PATH
if(CMAKE_PREFIX_PATH)
    if(NOT GRIB_API_PATH)
        set(GRIB_API_PATH ${CMAKE_PREFIX_PATH})
    endif()
endif()

if(GRIB_API_PATH)
    if(EXISTS "${GRIB_API_PATH}/lib")
        set(GRIB_API_LIB_DIR "${GRIB_API_PATH}/lib")
    else()
    endif()

    if(EXISTS "${GRIB_API_PATH}/lib64")
        set(GRIB_API_LIB_DIR "${GRIB_API_PATH}/lib64")
    endif()

    set(GRIB_API_LIBRARIES_STR "-L${GRIB_API_PATH}/lib -L${GRIB_API_PATH}/lib64 ${GRIB_API_LIBRARIES_STR}")
endif()

foreach (inc ${GRIB_API_INCLUDE_DIRS})
    set(GRIB_API_INCLUDE_DIRS_STR "${GRIB_API_INCLUDE_DIRS_STR} -I${inc}")
endforeach()


configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile @ONLY)
install( FILES ${CMAKE_BINARY_DIR}/bin/compile  
         DESTINATION ${MV_BIN_DIR}
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)




##################
#
# CONFIG.site

if( DEFINED NETCDF_PATH )
    set(NETCDF_BIN "${NETCDF_PATH}/bin")
else()
    set(NETCDF_BIN "")
endif()


ecbuild_get_date(TODAYS_DATE)


# Add certain paths to LD_LIBRARY_PATH.
# If the given path is not a standard system one, then add it to our list
# of paths to add to LD_LIBRARY_PATH on Metview's startup. We want to
# avoid adding system paths here because they can override non-default
# paths (case in point: the wrong OpenGL library has been known to be
# picked up - used by VAPOR).

set(SYS_LIBDIRS "/usr/lib64" "/usr/lib64/" "/usr/lib" "/usr/lib/" "")
set(METVIEW_LD_PATHS "")

foreach(LIBPATH ${MAGICS_LIB_DIR} ${ODB_API_LIB_DIR} ${GRIB_API_LIB_DIR})
    list(FIND SYS_LIBDIRS ${LIBPATH} IND)
    #message(STATUS "IS ${LIBPATH} ${IND}")
    if(IND EQUAL -1)  # path not in the list of system paths
        set(METVIEW_LD_PATHS "${LIBPATH}:${METVIEW_LD_PATHS}")
    endif()
endforeach()


configure_file(CONFIG.site.in  CONFIG.site @ONLY)


# concatenate CONFIG.site and metview_base into the Metview startup script

add_custom_command( 
    OUTPUT  ${FULL_STARTUP_SCRIPT_PATH}
    COMMAND cat  ${CMAKE_CURRENT_BINARY_DIR}/CONFIG.site > ${FULL_STARTUP_SCRIPT_PATH} \; cat ${CMAKE_CURRENT_SOURCE_DIR}/metview_base >> ${FULL_STARTUP_SCRIPT_PATH} \; chmod uga+x ${FULL_STARTUP_SCRIPT_PATH}
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/CONFIG.site ${CMAKE_CURRENT_SOURCE_DIR}/metview_base
)


# create a 'production' version of this - just the same, but with
# METVIEW_VERSION=prod instead of dev

set(PROD_TEMPORARY_STARTUP_SCRIPT "${FULL_STARTUP_SCRIPT_PATH}_prod")

add_custom_command( 
    OUTPUT  ${PROD_TEMPORARY_STARTUP_SCRIPT}
    COMMAND sed "s/METVIEW_VERSION=dev/METVIEW_VERSION=prod/g" ${FULL_STARTUP_SCRIPT_PATH} > ${PROD_TEMPORARY_STARTUP_SCRIPT}
    DEPENDS ${FULL_STARTUP_SCRIPT_PATH}
)


ADD_CUSTOM_TARGET(mvs ALL DEPENDS ${FULL_STARTUP_SCRIPT_PATH} ${PROD_TEMPORARY_STARTUP_SCRIPT})


# when we install, we actually want to install the production script and rename it
install( FILES       ${PROD_TEMPORARY_STARTUP_SCRIPT}
         RENAME      ${METVIEW_SCRIPT}
         DESTINATION bin # NOT ${MV_BIN_DIR}!
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)



## TODO
## If we are building this outside ECMWF, then we want different proxy settings
## (used currently by the OGC clients). We achieve this by simply changing the
## default setting in the ConfigDef file. We can do this with a  a search/replace
## operation. This relies very much on the proxy setting having a uniqe 'signature'
## so that the search/replace can operate on a single line.
#
#if test "x$SITE_NAME" != 'xecmwf'; then
#    configdef=share/metview/etc/ConfigDef
#    configtmp=${configdef}.tmp
#    echo "Not at ECMWF: resetting the default proxy setting in ${configdef}."
#    chmod u+w $configdef
#    sed "s/	} = yes/	} = no/g"  $configdef > $configtmp
#    mv $configtmp $configdef
#fi

#ecbuild_dont_pack(FILES mv_cp metview_local.ecmwf metview_local2.ecmwf)

ecbuild_dont_pack(REGEX "metview_local*.ecm*")
ecbuild_dont_pack(FILES "mv_cp;mv_debug_env.sh;update_MetApps_files.sh")

=== src/AppMod/CMakeLists.txt ===

QT4_WRAP_CPP(savepool_MOC savepool.h)


ecbuild_add_executable( TARGET       savepool 
                        SOURCES      savepool.cc ${savepool_MOC}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${FDB_LIBRARIES}
                    )
######## xxxxx ODB????



ecbuild_add_executable( TARGET       MvMailTo
                        SOURCES      MvMailTo.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )


ecbuild_add_executable( TARGET       MvCompress
                        SOURCES      MvCompress.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

if(ENABLE_MOTIF)

ecbuild_add_executable( TARGET       exampool
                        SOURCES      examcback.cc exammain.c examwidgets.h
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${X11_INCLUDE_DIR} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_MOTIF_LIBS} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES} ${MOTIF_LIBRARIES} ${X11_LIBRARIES}
                    )


ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/maill.c
	COMMAND lex -l ${CMAKE_CURRENT_SOURCE_DIR}/maill.l\; sed -e s/yy/mail/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/maill.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/maill.l)

ADD_CUSTOM_TARGET(maillex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/maill.c)

ecbuild_add_executable( TARGET       mvnews
                        SOURCES      newsmain.c newscback.c maill.c
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${X11_INCLUDE_DIR} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_MOTIF_LIBS} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES} ${MOTIF_LIBRARIES} ${X11_LIBRARIES}
                    )
ADD_DEPENDENCIES(mvnews maillex)


ecbuild_add_executable( TARGET       mvmail
                        SOURCES      mailmain.c mailcback.c
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${X11_INCLUDE_DIR} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_MOTIF_LIBS} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES} ${MOTIF_LIBRARIES} ${X11_LIBRARIES}
                    )

ecbuild_add_executable( TARGET       checkdisplay
                        SOURCES      checkdisplay.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${X11_INCLUDE_DIR} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_MOTIF_LIBS} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES} ${MOTIF_LIBRARIES} ${X11_LIBRARIES}
                    )

endif()

=== src/BufrExaminer/CMakeLists.txt ===

QT4_WRAP_CPP(Bufr_MOC BufrExaminer.h)


ecbuild_add_executable( TARGET       BufrExaminer
                        SOURCES      MvMain.cc BufrMetaData.cc BufrExaminer.cc MvQBufrDumpModel.cc
                                     BufrExaminer.h BufrMetaData.h MvQBufrDumpModel.h ${Bufr_MOC}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )

=== src/DebugTools/CMakeLists.txt ===

### TODO: bin/mvmon  bin/MvMonitor


QT4_WRAP_CPP(XServ_MOC XServ.h)
QT4_ADD_RESOURCES(XServ_RES XServ.qrc)


set(xserv_srcs
    XServ.cc XServ.h  ${XServ_MOC} ${XServ_RES}
)



ecbuild_add_executable( TARGET       xserv
                        SOURCES      ${xserv_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${METVIEW_QT_LIBRARIES}
                    )

################################

if(ENABLE_MOTIF)

set(mvmon_srcs
    moncback.cc mvmon.c
)

ecbuild_add_executable( TARGET       mvmon
                        SOURCES      ${mvmon_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ../libMvMotif ${X11_INCLUDE_DIR}
                        LIBS         ${METVIEW_MOTIF_LIBS} ${STANDARD_METVIEW_LIBS} ${MOTIF_LIBRARIES} ${X11_LIBRARIES}
                    )

endif()
################################

QT4_WRAP_CPP(MvMonitor_MOC ProcMonitor.h)
QT4_ADD_RESOURCES(MvMonitor_RES debug.qrc)

#message(STATUS "WRAP_CPP: ${MvMonitor_MOC}")
#message(STATUS "ADD_RES: ${MvMonitor_RES}")


set(MvMonitor_srcs
    MvMainMonitor.cc ProcMonitor.cc MvProcNode.cc MvQProcModel.cc
    MvProcNode.h MvQProcModel.h ${MvMonitor_MOC} ${MvMonitor_RES}
)


# note that we need the X11 libraries if Motif is enabled because of MvQX11Application
ecbuild_add_executable( TARGET       MvMonitor
                        SOURCES      ${MvMonitor_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${X11_INCLUDE_DIR} ${METVIEW_QT_INCLUDE_DIRS} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${X11_LIBRARIES}
                    )

=== src/Desktop/CMakeLists.txt ===

QT4_WRAP_CPP(Desktop_MOC 
                         MvQAdvancedSearch.h
                         MvQBookmarks.h
                         MvQEditor.h
                         MvQFileBrowser.h
                         MvQDetailedFolderView.h
                         MvQIconMimeData.h
                         MvQColourListLine.h
                         MvQDrawerPanel.h
                         MvQPathWidget.h
                         Runnable.h
                         MvQFileWatcher.h
                         MvQFind.h
                         MvQFolderDrawerPanel.h
                         MvQFolderHistory.h
                         MvQFolderPanel.h
                         MvQFolderWidget.h
                         MvQFolderModel.h
                         MvQIconFolderView.h
                         MvQFolderViewDelegate.h
                         MvQFolderWatcher.h
                         #MvQHelpBrowser.h
                         MvQListFolderViewBase.h
                         MvQNewIconWidget.h
                         MvQRequestPanelLine.h
                         MvQBoolLine.h
                         MvQColourLine.h
                         MvQComboBoxLine.h
                         MvQIconHolder.h
                         MvQIconLine.h
                         MvQScrolledTextLine.h
                         MvQSearchPanel.h
                         MvQStringLine.h
                         MvQTextLine.h
                         MvQRequestPanelHelp.h
                         MvQColourHelp.h
                         MvQListHelp.h
                         MvQIconHelp.h
                         MvQLogDialog.h
                         MvQPageView.h
                         MvQProductBrowser.h
                         MvQRequestPanelWidget.h
                         MvQScriptHelp.h
                         MvQSliderLine.h
                         MvQStationsHelp.h
                         MvQTemplateDrawer.h
                         MvQTemporaryEditor.h
                         #MvQTools.h
                         MvQViewDrawer.h
                         ComputeEditor.h
                         ViewEditor.h
                         SimpleEditor.h
                         FamilyEditor.h
                         MacroParamEditor.h
                         Tools.h
                         Input.h
)

QT4_ADD_RESOURCES(Desktop_RES desktop.qrc)

set(desktop_srcs    MvMainQtBrowser.cc
                    MvQ.cc
                    MvQActionList.cc
                    MvQAdvancedSearch.cc
                    MvQBookmarks.cc
                    MvQBoolLine.cc
                    MvQColourHelp.cc
                    MvQColourLine.cc
                    MvQColourListLine.cc
                    MvQComboBoxLine.cc
                    MvQContextMenu.cc
                    MvQDesktop.cc
                    MvQDesktopSettings.cc
                    MvQDetailedFolderView.cc
                    MvQDrawerPanel.cc
                    MvQDrawerView.cc
                    MvQDropTarget.cc
                    MvQEditor.cc
                    MvQExternalHelp.cc
                    MvQFileBrowser.cc
                    MvQFileWatcher.cc
                    MvQFind.cc
                    MvQFolderDrawerPanel.cc
                    MvQFolderHistory.cc
                    MvQFolderItemProperty.cc
                    MvQFolderModel.cc
                    MvQFolderNavigation.cc
                    MvQFolderPanel.cc
                    MvQFolderViewBase.cc
                    MvQFolderViewDelegate.cc
                    MvQFolderViewHandler.cc
                    MvQFolderWatcher.cc
                    MvQFolderWidget.cc
                    MvQGeoHelp.cc
                    #MvQHelpBrowser.cc
                    MvQIconFolderView.cc
                    MvQIconHelp.cc
                    MvQIconHelpView.cc
                    MvQIconHolder.cc
                    MvQIconLine.cc
                    MvQIconMimeData.cc
                    MvQIconObjectModel.cc
                    MvQIconProvider.cc
                    MvQIconStripView.cc
                    MvQListHelp.cc
                    MvQListFolderViewBase.cc
                    MvQLogDialog.cc
                    MvQMessageBox.cc
                    MvQNewIconWidget.cc
                    MvQNoneLine.cc
                    MvQPageView.cc
                    MvQPalette.cc
                    MvQPathWidget.cc
                    MvQProductBrowser.cc
                    MvQRecentIcons.cc
                    MvQRequestPanelHelp.cc
                    MvQRequestPanelLine.cc
                    MvQRequestPanelWidget.cc
                    MvQScriptHelp.cc
                    MvQScrolledTextLine.cc
                    MvQSearchPanel.cc
                    MvQSliderLine.cc
                    MvQStationsHelp.cc
                    MvQStringLine.cc
                    MvQTemplateDrawer.cc
                    MvQTemporaryEditor.cc
                    MvQTextLine.cc
                    MvQTheme.cc
                    #MvQTools.cc
                    MvQViewDrawer.cc
                    Action.cc
                    ActionCommand.cc
                    Command.cc
                    ComputeEditor.cc
                    ConfigLoader.cc
                    Counted.cc
                    Dependancy.cc
                    Drop.cc
                    Editor.cc 
                    EditorDrawerFactory.cc
                    EditorFactory.cc
                    EditTransaction.cc
                    FamilyEditor.cc
                    FamilyObject.cc
                    FamilyScanner.cc
                    FileObject.cc
                    Folder.cc
                    FolderDatabase.cc
                    FolderInfo.cc
                    FolderSearchData.cc
                    FolderSettings.cc
                    HelpFactory.cc
                    IconClass.cc 
                    IconFactory.cc
                    IconGroupTools.cc
                    IconInfo.cc
                    IconObject.cc
                    Input.cc
                    InternalService.cc
                    InternalTask.cc
                    Items.cc
                    Language.cc
                    LineFactory.cc
                    Log.cc
                    MacroGuiObject.cc
                    MacroObject.cc
                    MacroParamEditor.cc
                    MacroParamObject.cc
                    MacroParamState.cc
                    MessageObserver.cc
                    MethodCommand.cc
                    MetviewService.cc
                    MetviewTask.cc
                    NoEditor.cc
                    Parameter.cc
                    Product.cc
                    ProductFolder.cc
                    Protocol.cc
                    Queue.cc
                    RequestPanel.cc
                    RequestPanelItem.cc
                    ReplyObserver.cc
                    ResolveTransaction.cc
                    RootFolder.cc
                    Runnable.cc
                    ShellService.cc
                    ShellTask.cc
                    Service.cc
                    ServiceEditor.cc
                    SimpleEditor.cc
                    StandardObject.cc
                    State.cc
                    SystemFolder.cc
                    Task.cc
                    TeeBuffer.cc
                    TeeStream.cc
                    TemporaryEditor.cc
                    TemporaryFolder.cc
                    TemporaryObject.cc
                    Tools.cc
                    Transaction.cc
                    ViewEditor.cc
                    Wastebasket.cc)



ecbuild_add_executable( TARGET       Desktop
                        SOURCES      ${desktop_srcs}
                                     ${Desktop_MOC}
                                     ${Desktop_RES}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${X11_INCLUDE_DIR} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${GDBM_LIB} ${X11_LIBRARIES}
                    )

=== src/FlextraExaminer/CMakeLists.txt ===

QT4_WRAP_CPP(FlextraExaminer_MOC FlextraExaminer.h)


ecbuild_add_executable( TARGET       FlextraExaminer
                        SOURCES      MvMain.cc
                                     FlextraExaminer.cc
                                     MvQHighlighter.cc
                                     FlextraExaminer.h
                                     MvQHighlighter.h 
                                     ${FlextraExaminer_MOC}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )

=== src/GeopExaminer/CMakeLists.txt ===

QT4_WRAP_CPP(Geop_MOC GeopExaminer.h)


ecbuild_add_executable( TARGET       GeopExaminer
                        SOURCES      MvMain.cc GeopExaminer.cc GeopExaminer.h MvGeoPointsModel.cc MvGeoPointsModel.h ${Geop_MOC}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )

=== src/GribExaminer/CMakeLists.txt ===

QT4_WRAP_CPP(Grib_MOC GribExaminer.h)


ecbuild_add_executable( TARGET       GribExaminer
                        SOURCES      MvMain.cc GribExaminer.cc  MvQGribDumpModel.cc GribExaminer.h MvQGribDumpModel.h ${Grib_MOC}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )

=== src/MacroEditor/CMakeLists.txt ===

QT4_WRAP_CPP      (MacroEd_MOC MvMain.h FindTextDialog.h Highlighter.h MacroEdit.h FunctionListDialog.h mvplaintextedit.h
                   CodeTemplateDialog.h GotoLineDialog.h RunDialog.h TabsDialog.h VerbFunctionHelpDialog.h MacroEdit.h)
QT4_ADD_RESOURCES (MacroEd_RES MacroEdit.qrc)
QT4_WRAP_UI       (MacroEd_FORMS_HEADERS CodeTemplateDialog.ui FunctionListDialog.ui VerbFunctionHelpDialog.ui
                   FindTextDialog.ui MacroEdit.ui GotoLineDialog.ui RunDialog.ui TabsDialog.ui)

set(macroeditor_srcs MvMain.cc
                     Highlighter.cc
                     MacroEdit.cc
                     CodeTemplateDialog.cc
                     FindTextDialog.cc
                     GotoLineDialog.cc
                     RunDialog.cc
                     TabsDialog.cc
                     FunctionListDialog.cc
                     VerbFunctionHelpDialog.cc
                     mvplaintextedit.cc
                     MacroHelper.cc
                     MagMLHelper.cc
                     ShellHelper.cc
                     PlainTextHelper.cc
                     LanguageHelper.cc
                     LanguageHelperFactory.cc
                     VerbFunctionHelp.cc
                     CodeTemplateDialog.h
                     FindTextDialog.h
                     FunctionListDialog.h
                     GotoLineDialog.h
                     Highlighter.h
                     LanguageHelper.h
                     LanguageHelperFactory.h
                     MacroEdit.h
                     MacroHelper.h
                     MagMLHelper.h
                     ShellHelper.h
                     MvMain.h
                     PlainTextHelper.h
                     RunDialog.h
                     MacroRunOptions.h
                     TabsDialog.h
                     TabsSettings.h
                     VerbFunctionHelp.h
                     VerbFunctionHelpDialog.h
                     mvplaintextedit.h)

#include_directories( CMAKE_CURRENT_BINARY_DIR . )

ecbuild_add_executable( TARGET       MacroEditor
                        SOURCES      ${MacroEd_FORMS_HEADERS}
                                     ${MacroEd_MOC}
                                     ${MacroEd_RES}
                                     ${macroeditor_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}
                                     ${METVIEW_STANDARD_INCLUDES} ${X11_INCLUDE_DIR} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${X11_LIBRARIES}
                    )

=== src/MagML/CMakeLists.txt ===

ecbuild_add_executable( TARGET       MagML
                        SOURCES      MagML.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS} ${MAGICS_DEFINITIONS}
                        INCLUDES     ${MAGICS_INCLUDE_DIRS} ${METVIEW_QT_INCLUDE_DIRS} ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${MAGICS_LIBRARIES}
                    )


metview_module_files(ETC_FILES ObjectSpec.MagML
                     XPM_FILES MAGML.xpm)

=== src/MarsCatalog/CMakeLists.txt ===

QT4_WRAP_CPP(MarsCat_MOC MvQMarsBrowser.h MvQMarsCatalog.h)
QT4_ADD_RESOURCES(MarsCat_RES mars.qrc)

set(mars_cat_srcs
    MvMain.cc
    MvQMarsBrowser.cc
    MvQMarsCatalog.cc
    json_spirit_reader.cpp
    json_spirit_value.cpp
    json_spirit_writer.cpp
    json_spirit.h
    MvQMarsBrowser.h
    MvQMarsCatalog.h
    json_spirit_reader.h
    json_spirit_value.h
    json_spirit_writer.h)


ecbuild_add_executable( TARGET       MarsCatalogue
                        SOURCES      ${mars_cat_srcs} ${MarsCat_MOC} ${MarsCat_RES}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )

#metview_module_files(ETC_FILES ObjectSpec.MarsCatalog
#                     XPM_FILES MARS_CATALOG.xpm)

# XXX in the future we may need to distribute the WebMars directory as well

=== debian/changelog ===
metview (4.5.6-5.2ubuntu1) wily; urgency=medium

  * Remove build dependency on libnetcdf-cxx-legacy-dev. We are not doing
    that transition in wily, as far as I can tell.

 -- Logan Rosen <logan@ubuntu.com>  Tue, 25 Aug 2015 01:40:11 -0400

metview (4.5.6-5.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Move from experimental to unstable.
  * Rebuild with magics++ for libterralib & netcdf transitions.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 23 Aug 2015 23:27:34 +0200

metview (4.5.6-5.1) experimental; urgency=medium

  * Non-maintainer upload.
  * Add build dependency on libnetcdf-cxx-legacy-dev for netcdf transition.
    (closes: #794027)
  * Add build dependency on gfortran required for the build.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 22 Aug 2015 17:22:04 +0200

metview (4.5.6-5) experimental; urgency=medium

  * Build against libterralib3 for g++5 transition.
  * Patch: Move from Qt4 to Qt5
  * Temporarily undo netcdf transition until gcc5 transition done.

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 07 Aug 2015 09:24:33 +0100

metview (4.5.6-4exp1) experimental; urgency=medium

  * Build against magics >= 2.24.7-4 for netcdf transition.
  * Drop dependency on scm, which metview does not use. It uses 'scm'
    for 'single column model', something else entirely 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 28 Jul 2015 14:23:43 +0100

metview (4.5.6-3) unstable; urgency=medium

  * B-D on gfortran. Strange, this wasn't needed in my amd64 sbuild 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 28 Jul 2015 10:30:27 +0100

metview (4.5.6-2) unstable; urgency=medium

  * B-D on flex, bison, libhdf5-dev directlty, latest magics++. Closes: #793546. 
  * Pre-generate /etc/* files on non-sbuild run, as build uses network
    connection to localhost not available in sbuilds.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 26 Jul 2015 20:17:08 +0100

metview (4.5.6-1) unstable; urgency=medium

  * New upstream release.
  * Move to cmake-based build
  * Depend on g++ >= 4:4.5.0 for transition. Closes: #778004.
  * Depend on magics upgrade for new release. Closes: #793176.
  * Update homepage URL. Closes: #769180.
  * fix-colors.patch: Fixed upstream.
  * syserrlist.patch temporarily disabled
  * no-m32 patch temporarily disabled.
  * Need to build-depend on libgrib-api-tools
  * Now B-D on openjpeg-dev. 
  * Move metview_bin/* to /usr/lib/$(ARCH)/metview for multi-arch safety

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 22 Jul 2015 19:39:15 +0100

=== debian/control ===
Source: metview
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9), 
  flex, bison, libhdf5-dev, libpango1.0-dev, chrpath,
  libqt5webkit5-dev, qtbase5-dev, libqt5xmlpatterns5-dev,
  libgrib-api-dev, libgrib-api-tools,
  libemos-dev, libboost-dev,
  libmagics++-metview-dev, libmagics++-dev (>= 2.24.7-3),
  libmotif-dev, libxmu-dev, libgdbm-dev, libcurl4-gnutls-dev,
  libcairo2-dev, pkg-config, swig, libexpat1-dev,
  libterralib-dev, ksh, libproj-dev,
  libgd-dev, imagemagick, libnetcdf-dev, libnetcdf-cxx-legacy-dev,
  libopenjpeg-dev, cmake, flextra, gfortran
Build-Conflicts: lesstif2-dev
Standards-Version: 3.9.6
Homepage: https://software.ecmwf.int/wiki/display/METV/Metview
Vcs-Git: git://anonscm.debian.org/debian-science/packages/metview.git

Package: metview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ksh | mksh | pdksh | zsh, 
 x11-utils, metview-data, python
Recommends: magics++
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview-dev
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-format
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic -fPIC
export DEB_BUILD_MAINT_OPTIONS
export DEB_CFLAGS_MAINT_APPEND
export QT_SELECT=5

# Needed for sbuild. metview creates temp directories during build
export HOME:=/tmp
export METVIEW_LOCALHOST:=127.0.0.1
export METVIEW_DEBUG:=1

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
PATH:=$(PATH):$(CURDIR)/scripts
AUTOGENERATED:= libmetview-dev.install  metview.install
MV_DIR:=/usr/lib/$(DEB_HOST_MULTIARCH)/metview
export METVIEW_DIR_DEV:=$(CURDIR)/debian/build
export METVIEW_BIN:=$(METVIEW_DIR_DEV)/bin

# magic debhelper rule
%:
	dh $@ --buildsystem=cmake --builddirectory=$(METVIEW_DIR_DEV)

override_dh_auto_clean:
	dh_clean
	rm -rf $(METVIEW_DIR_DEV)
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

# magics++ upstream ships with a copy of terralib, which is not used in Debian. 
# Instead we use # a shared terralib library, and so need to include terralib.
# Also -fPIC, for some reason.

override_dh_auto_configure:
	chmod +x ./scripts/*.mv
	dh_auto_configure -- \
		-DMETVIEW_SITE=debian  \
		-DCMAKE_BUILD_TYPE=Debug \
		-DMETVIEW_EXTRA_LIBRARIES='terralib' \
		-DMETVIEW_EXTRA_INCLUDES='/usr/include/terralib/kernel' \
		-DMAGICS_PATH=/usr \
		-DBUILD_SHARED_LIBS=On \
		-DENABLE_RPATHS=Off \
		-DFLEXTRA_PATH=/usr/bin/flextra
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g'  < debian/CONFIG.site.in \
		> $(METVIEW_DIR_DEV)/scripts/CONFIG.site 
	# These get generated ok on a machine with network connection, but fail on sbuilds, etc.
	# so copy pre-generated versions stored in etc
	mkdir -p debian/build/share/metview/etc/
	cp debian/etc/* debian/build/share/metview/etc/

override_dh_auto_test:
	@echo "Checks disabled for the moment due to syntax errors in tests" 

override_dh_fixperms:
	dh_fixperms
	rm -rf debian/metview-data/usr/share/applications
	chmod +x debian/metview/$(MV_DIR)/mv_compress
	chmod -x debian/metview/$(MV_DIR)/metview_*.common
	chmod -x debian/metview/$(MV_DIR)/metview_stat
	chmod -x debian/metview/$(MV_DIR)/metview_patches
	file debian/metview/$(MV_DIR)/* | grep ELF | cut -f1 -d: | xargs chrpath -d
	# This directory won't exist on arch-only builds, so ...
	[ ! -d debian/metview-data/usr/share/metview ] || (  \
		chmod -R -x debian/metview-data/usr/share/metview/* ; \
		find debian/metview-data/usr/share/metview -type d -exec chmod 755 {} \;  )
